package com.eactive.eai.adapter.ftp;

import java.io.File;
import java.io.IOException;
import java.net.Socket;

import org.apache.commons.lang3.StringUtils;
import org.apache.commons.net.ftp.FTPFile;

import com.eactive.eai.adapter.socket.config.ConfigurationContext;
import com.eactive.eai.adapter.socket.service.SocketService;
import com.eactive.eai.batch.common.CalendarUtil;
import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.common.StringUtil;
import com.eactive.eai.batch.doc.BatchDoc;
import com.eactive.eai.batch.ftp.FTPUtil;
import com.eactive.eai.batch.running.BatchRunningJobManager;
import com.eactive.eai.common.exception.ExceptionUtil;
import com.eactive.eai.common.property.PropManager;
import com.eactive.eai.common.util.DatetimeUtil;
import com.eactive.eai.common.util.Logger;

// 여신 메타 자료 수신 ( SFTP )
// IP : 10.0.249.68 PORT : 22
// ID : kjbankftp PWD: !@$#kjbank@mcgFTP
// 수신: 
// 파일명  META_YYYYMMDDHH.jar
// TEST / PROD 별도 서버 구성
// 접속후 send 폴더에 파일이 존재 함.
// 파일 수신 후  send/send.done 폴더 아래로 파일 이동 바람.
public class FTPMC extends Transfer implements SocketService{

    private static final String PROP_GROUP_NAME_PREFIX = "TelegramInfo";
    private static final String REMOTE_PATH = "remote.path";
    private static final String REMOTE_BACKUP_PATH = "remote.backup.path";

	public void sendFile(BatchDoc batchDoc) throws Exception {
		throw new Exception("해당 Component 에 의한 FTP 송신이 구현되지 않았습니다.");
	}

	public void recvFile(BatchDoc batchDoc) throws Exception {
		logger.info("[FTPMC] ■ 대외기관→FEP 파일 수신 시작...... ");
		firstActivity = System.currentTimeMillis();
		setLastActivity();
		BatchRunningJobManager.getInstance().addRunningJobInfo( batchDoc.getBatchMsg().getHeader().getUUID(), this, batchDoc);
		//2. System FTP Shell 명령어를 Runtime 으로 실행
		try {
			
			String ipaddress = batchDoc.getBatchMsg().getHeader().getRemoteIP();
			int    port      = Integer.parseInt(batchDoc.getBatchMsg().getHeader().getPort());
			String userid    = batchDoc.getBatchMsg().getHeader().getUserID();
			String passwd    = batchDoc.getBatchMsg().getHeader().getUserPassword();
			
	        String propName = PROP_GROUP_NAME_PREFIX + "{" +
                    batchDoc.getBatchMsg().getHeader().getProcessCode() +
                    "_" +
                    batchDoc.getBatchMsg().getHeader().getInstitutionCode() + "}";
	        PropManager pmanager = PropManager.getInstance();

	        String remotePath = pmanager.getProperties(propName).getProperty(REMOTE_PATH);
	        String remote_backup_Path = pmanager.getProperties(propName).getProperty(REMOTE_BACKUP_PATH);
	        
			if ( remotePath == null ){
				throw new Exception("해당 기관에 전송 경로가 지정되어 있지 않습니다. -propName:" + propName + "," + REMOTE_PATH);
			}
			if ( !remotePath.endsWith("/") )
				remotePath = remotePath + "/";

	        String authType = pmanager.getProperties(propName).getProperty(AUTH_TYPE);
	        if (StringUtils.isBlank(authType)) {
	        	authType = AUTH_TYPE_ID; // id
	        }
			//20220712 
			String connTimeoutStr = pmanager.getProperties(propName).getProperty(CONNECTION_TIMEOUT, "10");
			int connTimeout = Integer.parseInt(connTimeoutStr);
			String setTimeoutStr = pmanager.getProperties(propName).getProperty(READ_TIMEOUT, "10");
			int setTimeout =  Integer.parseInt(setTimeoutStr);			
			String bandWidthLimit = pmanager.getProperties(propName).getProperty(BADNWIDTH, "0");
			bandWidthLimit = bandWidthLimit.replace("K", "000").replace("M", "000000").replaceAll(",", "");
			int bandWidth = Integer.parseInt(bandWidthLimit);		
	        
			logger.debug( "[FTPMC]FileName:" + batchDoc.getBatchMsg().getHeader().getFileName());
			String reqFileName = batchDoc.getBatchMsg().getHeader().getFileName();
			String baseDate = DatetimeUtil.getCurrentDate();
			if ( reqFileName != null && reqFileName.length() > 8 ){
				if ( DatetimeUtil.isRightDate(reqFileName.substring(reqFileName.length() - 8 )) ){
					baseDate = reqFileName.substring(reqFileName.length() - 8 );
					batchDoc.getBatchMsg().getHeader().setBaseDate(baseDate);
				}
			}

			reqFileName = batchDoc.getBatchMsg().getHeader().getBizCode() + "_" + baseDate;
			logger.debug( "[FTPMC]reqFileName:" + reqFileName );

			
            try {
    			FTPFile[] list = FTPUtil.listFiles(ipaddress, port, userid, passwd, remotePath, null, true, batchDoc.getLogger(Logger.LOGGER_ADAPTER), authType);
    			for ( int inx = 0 ; inx < list.length; inx++){
    				FTPFile file = list[inx];
    				if ( file.getName().startsWith(reqFileName) ){
    					batchDoc.getBatchMsg().getHeader().setFileSize(file.getSize());
    					batchDoc.getBatchMsg().getBody().setRecCnt(1);
    					batchDoc.getBatchMsg().getBody().setPhaseStartTime(CalendarUtil.getCurrentTimeNoDash());
    		            batchDoc.getBatchMsg().getHeader().setFileName(file.getName());
    					LogUtil.setLogFileStart(batchDoc);
    					//FTPUtil.retrieve(ipaddress, port, userid, passwd, remotePath + "/" + file.getName(), batchDoc.getBatchMsg().getHeader().getFilePath(), true, batchDoc.getLogger(ElinkLogger.LOGGER_ADAPTER));
    					FTPUtil.retrieve(batchDoc, ipaddress, port, userid, passwd, remotePath, file.getName(), batchDoc.getBatchMsg().getHeader().getFilePath(),
    							connTimeout, setTimeout, true, bandWidth, batchDoc.getLogger(Logger.LOGGER_ADAPTER), authType);
    					
    					//batchDoc.getBatchMsg().getHeader().setFileSize(fileSize);
    					batchDoc.getBatchMsg().getHeader().setTotRecCnt(1);
    					String recvFile = batchDoc.getBatchMsg().getHeader().getFilePath() + File.separator +  file.getName();
    					File rcvRealFile = new File( recvFile );
    					File rcvChkFile = new File( StringUtil.realToRootDir(recvFile) );

    					try {
    						File rcvArchFile = new File( StringUtil.realToArchDir(recvFile) );
    			            if (rcvRealFile.exists() && rcvRealFile.length() == batchDoc.getBatchMsg().getHeader().getFileSize() ) {
    			                //setFileHeaderAndTrailer(batchDoc, rcvRealFile);
    			                rcvRealFile.renameTo(rcvArchFile);
    			    			rcvChkFile.createNewFile();
    			            }else{
    			            	throw new Exception("파일수신에 실패하였습니다.");
    			            }
    		                //File 종료시간 설정
    		    			batchDoc.getBatchMsg().getBody().setPhaseEndTime(CalendarUtil.getCurrentTimeNoDash());
    						LogUtil.setLogFileEnd(batchDoc);
    					} catch (Exception e) {
    						throw e;
    					}
    					
    					try {
    						FTPUtil.rename(ipaddress, port, userid, passwd,remotePath + file.getName(), remotePath +remote_backup_Path +"/" + file.getName(), true, batchDoc.getLogger(Logger.LOGGER_ADAPTER), authType);
    					} catch (Exception e){
    						throw new Exception("파일수신후 백업디렉토리로 RENAME 실패하였습니다.");
    					}
    				}
    			}
            }catch ( Exception e ){
            	if ( !e.getMessage().contains("No such file"))
            		throw e;
            }
			
		           
        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            LogUtil.setErrorLog(batchDoc, ex.getMessage());
            logger.error( errMsg, ex );
            throw ex;
		} finally {
			this.disconnect();
        }
		logger.info("[FTPMC] ■ VAN사 → FEP 파일 수신 완료.");		
	}

	@Override
	public void shutdown() {
		
	}

	@Override
	public Socket getCurrentSocket() {
		return null;
	}

	@Override
	public boolean connect() {
		return false;
	}

	@Override
	public ConfigurationContext getContext() {
		return null;
	}

	@Override
	public void setControl(Object control) {
		
	}

	@Override
	public void notifyMessage() {
		
	}

	@Override
	public boolean idle(long timeout) {
		return false;
	}

	@Override
	public int getCurrentState() {
		return 0;
	}

	@Override
	public boolean isConnected() throws IOException {
		return false;
	}

	@Override
	public boolean isActive() {
		return false;
	}

	@Override
	public void checkActivity() {
		
	}

	@Override
	public String getRemoteIPAddress() {
		return null;
	}

	@Override
	public void setLastActivity() {
		lastActivity = System.currentTimeMillis();
	}

	@Override
	public long getFirstActivity() {
		return firstActivity;
	}

	@Override
	public long getLastActivity() {
		return lastActivity;
	}
}